Lattice Grid Buy a licence

demo D249

Arc diagram in Angular

Lay every node on one line and join related pairs with an arc, so the links read at a glance

type: 'arc', source, target, value

This lays every node on one line and joins related pairs with an arc above it. It makes the connections in a set of items read at a glance, so clusters and hubs stand out along a single axis.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import '@toclocoinc/lattice-grid/modules/chart-arc';  // opt in to the arc type
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div id="chart" style="height:320px"></div>' +
    '<lattice-grid [config]="grid" style="display:block;height:320px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    columns: [
      { field: 'source', title: 'From', filter: { type: 'set' } },
      { field: 'target', title: 'Calls', filter: { type: 'set' } },
      { field: 'calls', title: 'Calls / min', type: 'number', total: 'sum' },
    ],
    rows: [/* one edge a row: source, target, calls */],
  };

  ngAfterViewInit() {
    createChart({ grid: this.gridRef.grid, container: '#chart', type: 'arc', source: 'source', target: 'target', value: 'calls', title: 'Which service calls which' });
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});

Lattice Grid Buy a licence

demo D249

Arc diagram in React

Lay every node on one line and join related pairs with an arc, so the links read at a glance

type: 'arc', source, target, value

This lays every node on one line and joins related pairs with an arc above it. It makes the connections in a set of items read at a glance, so clusters and hubs stand out along a single axis.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/charts.esm.min.js';
  import 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/chart-arc.esm.min.js';  // opt in to the arc type

  const { LatticeGrid, LatticeChart } = createLatticeReact({ React, createGrid, createChart });

  const columns = [
      { field: 'source', title: 'From', filter: { type: 'set' } },
      { field: 'target', title: 'Calls', filter: { type: 'set' } },
      { field: 'calls', title: 'Calls / min', type: 'number', total: 'sum' },
  ];

  const rows = [/* one edge a row: source, target, calls */];

  function App() {
    const [grid, setGrid] = React.useState(null);

    return (
      <>
        {grid && (
          <LatticeChart grid={grid} type="arc" source="source" target="target" value="calls" title="Which service calls which" style={{ height: '320px' }} />
        )}
        <LatticeGrid
          rowKey="id"
          columns={columns}
          rows={rows}
          onGridReady={setGrid}
          style={{ height: '320px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>